import java.awt.Button;
import java.awt.Frame;

public class ButtonDemoFrame extends Frame
{
    private static String[] labels =
        { "North", "South", "East", "West", "Center" };
    private Button[] button;

    public ButtonDemoFrame()
    {
        super();

        setTitle( "Button Demo" );
        setSize( 300, 250 );

        button = new Button[labels.length];
        for ( int i = 0; i < labels.length; i++ )
            button[i] = makeButton( labels[i] );
        layoutButtons();
    }

    protected Button makeButton( String position )
    {
        Button localButton = new Button( position );
        localButton.addActionListener(
            new DemoButtonListener( localButton, this ) );
        return localButton;
    }

    public void scrambleButtons()
    {
        for ( int i = 0; i < button.length; i++ )
        {
            int slot = (int) (Math.random() * (button.length - i)) + i;
            if ( Math.random() < 0.5 )
            {
                Button temp  = button[i];
                button[i]    = button[slot];
                button[slot] = temp;
            }
        }

        layoutButtons();
    }

    protected void layoutButtons()
    {
        for ( int i = 0; i < labels.length; i++ )
            add( labels[i], button[i] );
    }
}
